VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cCFIntro"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private cSurface As cDXSurface
Private cColdFusion As cDXBitmap
Private cBackdrop As cDXBitmap
Private dsBounce(2) As cDirectSound
Private dsSnd As cDirectSound

Private Type Letter
    X As Integer
    Y As Integer
    YForce As Integer
    Bottom As Integer
End Type

Private cLetter(9) As Letter
Private cStage As Integer
Private Frame As Integer
Private cFinished As Boolean
Private cComplete As Boolean

Public Property Get Finished() As Boolean
    Finished = cFinished
End Property


Public Function BeginIntroduction(Surface As cDXSurface)
    cStage = 0
    cFinished = False
    Set cSurface = Surface
    Set cColdFusion = New cDXBitmap
    cColdFusion.CreateBitmap cSurface, "Image\Coldfusion.x", 630, 86
    Set cBackdrop = New cDXBitmap
    cBackdrop.CreateBitmap cSurface, "Image\Blank.x", 640, 480
    Set dsSnd = New cDirectSound
    dsSnd.CreateDirectSound Form1
    dsSnd.OpenWaveFile App.Path + "\Sound\snd1.x"
    Dim n As Integer
    For n = 0 To 2 Step 1
        Set dsBounce(n) = New cDirectSound
        dsBounce(n).CreateDirectSound Form1
    Next n
    dsBounce(0).OpenWaveFile App.Path + "\Sound\0tom2.x"
    dsBounce(1).OpenWaveFile App.Path + "\Sound\bounce.x"
    dsBounce(2).OpenWaveFile App.Path + "\Sound\0tom0.x"
    'Set our Letter properties
    Dim i As Integer
    For i = 0 To 9 Step 1
        cLetter(i).X = 5 + (i * 63)
        cLetter(i).Y = -200 - (((i - 4.5) ^ 2) * 6)
        cLetter(i).YForce = 0
        cLetter(i).Bottom = 170
    Next i
End Function

Public Function EndIntro()
    dsSnd.DestroyDirectSound
    dsBounce(0).DestroyDirectSound
    dsBounce(1).DestroyDirectSound
    dsBounce(2).DestroyDirectSound
    cColdFusion.DestroyBitmap
    cBackdrop.DestroyBitmap
End Function

Public Function Next_Frame()
    DoEvents
    Dim i As Integer
    Select Case cStage
        Case 0
            cSurface.RefreshScreen
            Frame = Frame + 1
            If Frame > 50 Then
                Frame = 0
                cStage = 1
            End If
        Case 1
            cBackdrop.DrawBitmap 0, 0, 640, 480, 0, 0, 640, 480, False
            For i = 0 To 9 Step 1
                cLetter(i).Y = cLetter(i).Y + cLetter(i).YForce
                If cLetter(i).Y > cLetter(i).Bottom Then
                    If cLetter(i).YForce < 7 Then
                        Randomize
                        ElseIf cComplete = False Then dsBounce(Int(2 * Rnd)).PlayWave False
                    End If
                    If cLetter(i).YForce < 7 And i = 0 Then cComplete = True
                    cLetter(i).Y = cLetter(i).Bottom
                    cLetter(i).YForce = -(cLetter(i).YForce - 8)
                    
                End If
                cLetter(i).YForce = cLetter(i).YForce + 1
                cColdFusion.DrawBitmap cLetter(i).X, cLetter(i).Y, 63, 86, i * 63, 0, 63, 86, True
            Next i
            cSurface.RefreshScreen
            Frame = Frame + 1
            If Frame > 150 Then
                Frame = 0
                cStage = 2
            End If
        Case 2
            cSurface.BrightenPalette 12
            dsSnd.PlayWave False
            Frame = Frame + 1
            If Frame > 10 Then
                Frame = 0
                cStage = 3
            End If
        Case 3
            cSurface.FadePalette 5 - (Frame / 23)
            Frame = Frame + 1
            If Frame > 100 Then
                Frame = 0
                cFinished = True
            End If
    End Select
End Function
