VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cDirectSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Andrew's DirectSound class
'Handles playing multiple wav files
'simultaneusly and at a fast rate; suitable
'for games.
'Created on Thursday 07/01/99

'WINDOWS FUNCTIONS---------------------------
Private Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByVal source As Long, ByVal length As Long)
Private Declare Function lstrcpy Lib "Kernel32" (ByVal lpszDestinationString1 As Any, ByVal lpszSourceString2 As Any) As Long
'
'---------------------------------------------

'PRIVATE VARIABLES---------------------------
Private ds As DirectSound
Private dsb(3) As DirectSoundBuffer
Private CurrentChannel As Integer
'
'--------------------------------------------

'Public Methods------------------------------
Public Sub CreateDirectSound(CompatibleDC As Object)
    DirectSoundCreate ByVal 0&, ds, Nothing
    ds.SetCooperativeLevel CompatibleDC.hwnd, DSSCL_NORMAL
End Sub

Public Sub DestroyDirectSound()
    Dim i As Integer
    Do While i < 4
        dsb(i).Stop
        Set dsb(i) = Nothing
        i = i + 1
    Loop
    Set ds = Nothing
End Sub

Public Function OpenWaveFile(name As String)
    Dim channel As Integer
    For channel = 0 To 3 Step 1
        Dim Filename As String
        Filename = name
'Before a wav file can be played using DirectX it must be firsted converted into the conventional DirectX sound format
        Dim hWave As Long
        Dim pcmwave As WAVEFORMATEX
        Dim lngSize As Long
        Dim lngPosition As Long
        Dim ptr1 As Long, ptr2 As Long, lng1 As Long, lng2 As Long
        Dim aByte() As Byte
    'Dim lngBufferSize As Long
    'Dim strBuffer As String
    ' Byte array to load the whole file
        ReDim aByte(1 To FileLen(Filename))
        hWave = FreeFile
        Open Filename For Binary As hWave
    ' Load the whole file in the byte array
        Get hWave, , aByte
        Close hWave
    ' Search "fmt" tag
        lngPosition = 1
        While Chr$(aByte(lngPosition)) + Chr$(aByte(lngPosition + 1)) + Chr$(aByte(lngPosition + 2)) <> "fmt"
        lngPosition = lngPosition + 1
    Wend
    ' Copy wave header to structure
    CopyMemory VarPtr(pcmwave), VarPtr(aByte(lngPosition + 8)), Len(pcmwave)
    ' Search "data" tag
    While Chr$(aByte(lngPosition)) + Chr$(aByte(lngPosition + 1)) + Chr$(aByte(lngPosition + 2)) + Chr$(aByte(lngPosition + 3)) <> "data"
        lngPosition = lngPosition + 1
    Wend
    ' Get the data size
    CopyMemory VarPtr(lngSize), VarPtr(aByte(lngPosition + 4)), Len(lngSize)
    
    ' Fill buffer description
    Dim dsbd As DSBUFFERDESC
    With dsbd
        .dwSize = Len(dsbd)
        .dwFlags = DSBCAPS_CTRLDEFAULT 'Or DSBCAPS_STATIC Or DSBCAPS_LOCSOFTWARE
        .dwBufferBytes = lngSize
        .lpwfxFormat = VarPtr(pcmwave)
    End With
    ' Create the sound buffer
    ds.CreateSoundBuffer dsbd, dsb(channel), Nothing
    ' Lock
    dsb(channel).Lock 0&, lngSize, ptr1, lng1, ptr2, lng2, 0&
    ' Copy data to buffer
    CopyMemory ptr1, VarPtr(aByte(lngPosition + 4 + 4)), lng1
    ' Copy second part if needed
    If lng2 <> 0 Then
        CopyMemory ptr2, VarPtr(aByte(lngPosition + 4 + 4 + lng1)), lng2
    End If
    ' Unlock
    ' Automation error if uncommented !
    'dsb.Unlock ptr1, lng1, ptr2, lng2
    Next channel
End Function

Public Function PlayWave(LoopWave As Boolean)
    If LoopWave = False Then dsb(CurrentChannel).Play 0, 0, 0 Else dsb(CurrentChannel).Play 0, 0, 1
    CurrentChannel = CurrentChannel + 1
    If CurrentChannel = 4 Then CurrentChannel = 0
End Function

Public Sub StopWave()
    Dim n As Integer
    For n = 0 To 3 Step 1
        CurrentChannel = 0
        dsb(n).Stop
    Next n
End Sub
'
'--------------------------------------------

